<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'

// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);

document.addEventListener("DOMContentLoaded", function () {
  // Obtener la tabla DataTable

  const dataTable = $('#datatable-index-constancias').DataTable();

  const dataTableNacional = $('#datatable-index-constancias-nacional').DataTable();

  dataTable.on("click", ".constancia", function () {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {

    
        window.location.href = route('constancias.pdf', {rfc:rowData.rfc,id:rowData.id,nombres:rowData.nombres, primerApellido:rowData.primerApellido, segundoApellido:rowData.segundoApellido,tipo:rowData.tipo,nacional:rowData.nacional,nombreRazonSocial:rowData.nombreRazonSocial});

      }
  });

  dataTableNacional.on("click", ".constancia", function () {
    const rowData = dataTableNacional.row($(this).closest("tr")).data();
    if (rowData) {

    
        window.location.href = route('constancias.pdf', {rfc:rowData.rfc,id:rowData.id,nombres:rowData.nombres, primerApellido:rowData.primerApellido, segundoApellido:rowData.segundoApellido,tipo:rowData.tipo,nacional:rowData.nacional,nombreRazonSocial:rowData.nombreRazonSocial});

      }
  });
 
  

});

export default {
  components: { DataTable, Multiselect },
  data() {
    return {
      products: null,
      productsNacional:null,
      RFC: '' ,
      CURP: '',
      nombres: '',
      primerApellido: '',
      segundoApellido: '',
      nombreRazonSocial: '',

      nombresNacional: '',
      primerApellidoNacional: '',
      segundoApellidoNacional: '',
      nombreRazonSocialNacional: '',
      isSearchDisabled: true,
      isSearchDisabledNacional: true,

      contenidoPrimerNombre: false,
      contenidoPrimerApellido: false,

      rfcNotEmpty: false,
    disableFields: false,

      TipoPersona: '',
      TipoPersonaNacional: '',
	      opcionesTipoPersona: this.variables && this.variables.tiposPersona
	      ? this.variables.tiposPersona.map(item => item)
	      : [], 

      loadingData: false,
      columns: [
        { data: null, render: function (data, type, row, meta) { return `${meta.row + 1}` } },
        { data: 'rfc', searchable: true }, // Habilitar búsqueda en esta columna
        { data: 'curp', searchable: true },
        { data: 'nombreCompleto'}, 
        {
          data: null,
          defaultContent: '<a title="Generar constancia" href="#a" v-on:click="constancia(rfc)" class="constancia text-warning"><i class=" mdi mdi-note-outline "></i></a>',
          targets: -1
        }
      ],
      
    }
  },

  watch: {
    RFC(newValue) {
      this.CURP = '';
      this.isSearchDisabled = newValue.trim() === '';
      this.nombres = '';
      this.primerApellido = '';
      this.segundoApellido = '';
      this.nombreRazonSocial= '';
    },

    CURP(newValue) {
      this.RFC = '';
      this.nombres = '';
      this.isSearchDisabled = newValue.trim() === '';
      this.primerApellido = '';
      this.segundoApellido = '';
    },

    nombreRazonSocial(newValue) {
      this.RFC = '';
      this.isSearchDisabled = newValue.trim() === '';
  
    },

    TipoPersona(newValue) {
    if (newValue === 1 || newValue === 2) {
      this.RFC = '';
      this.CURP = '';
      this.nombres = '';
      this.primerApellido = '';
      this.segundoApellido = '';
      this.nombreRazonSocial = '';
      this.isSearchDisabled = true;
    }
  },

    nombres(newValue) {
    this.RFC = '';
    this.CURP = '';
    this.isSearchDisabled = newValue.trim() === '' || this.primerApellido.trim() === '';
  },

  primerApellido(newValue) {
    this.RFC = '';
    this.CURP = '';
    this.isSearchDisabled = newValue.trim() === '' || this.nombres.trim() === '';
  },

  nombresNacional(newValue) {
    this.RFC = '';
    this.CURP = '';
    this.isSearchDisabledNacional = newValue.trim() === '' || this.primerApellidoNacional.trim() === '';
  },

  primerApellidoNacional(newValue) {
    this.RFC = '';
    this.CURP = '';
    this.isSearchDisabledNacional = newValue.trim() === '' || this.nombresNacional.trim() === '';
  },

  nombreRazonSocialNacional(newValue) {
      
      this.isSearchDisabledNacional = newValue.trim() === '';
  
    },

  },


  mounted() {
    const dataTable = $('#datatable-index-constancias').DataTable();
    const dataTableNacional = $('#datatable-index-constancias-nacional').DataTable();
    
    
  },

  props: {
	    variables: Object,
	},

 

  

  methods: {


  

getProducts() {
      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });
  axios.get(route('constancias.busqueda.estatal',{rfc:this.RFC,curp:this.CURP, nombreRazonSocial:this.nombreRazonSocial,nombres:this.nombres,primerApellido:this.primerApellido,segundoApellido:this.segundoApellido,})).then(
        response => {
          swal.close()
          this.products = response.data
        }
      )
    },

    getProductsNacional() {
      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });
  axios.get(route('constancias.busqueda.nacional',{nombreRazonSocial:this.nombreRazonSocialNacional,nombres:this.nombresNacional,primerApellido:this.primerApellidoNacional,segundoApellido:this.segundoApellidoNacional,})).then(
        response => {
          swal.close()
          this.productsNacional = response.data
        }
      )
    },



    create: function (event) {
      window.location.href = '/sanciones/create/servidores-publicos';

    },

   

    

    
  }
}
</script>


<template>

        <!-- start page title -->
        <div class="row">
          <div class="col-12">
            <div class="page-title-box d-sm-flex align-items-center justify-content-between">
              <h4 class="mb-sm-0 font-size-18">Generacion de constancias</h4>
            </div>
          </div>
        </div>
        <!-- end page title -->




            <!-- Contenido de la primera pestaña -->
            <div class="card">
                <div class="card-body">
                  <ul class="nav nav-pills nav-justified mb-3" id="pills-tab" role="tablist">
                    <li class="nav-item" role="presentation">
                      <button class="nav-link active" id="pills-home-tab" data-bs-toggle="pill" data-bs-target="#pills-home" type="button" role="tab" aria-controls="pills-home" aria-selected="true">Busqueda Estatal</button>
                    </li>
                  
                    <li class="nav-item" role="presentation">
                      <button class="nav-link" id="pills-profile-tab" data-bs-toggle="pill" data-bs-target="#pills-profile" type="button" role="tab" aria-controls="pills-profile" aria-selected="false">Busqueda Nacional</button>
                    </li>
                  </ul>
                  <div class="tab-content" id="pills-tabContent">
                    <div class="tab-pane fade show active" id="pills-home" role="tabpanel" aria-labelledby="pills-home-tab">
                      
                      <h4 class="card-title mb-4">Datos de busqueda</h4>
                      <div class="row">

                        <div class="col-md-2">
                          <div class="mb-3">
                            <label for="validationCustom04" class="form-label">Tipo de Persona</label>
                            <select name="sancionado[tipoPersonaId]" v-model="TipoPersona" class="form-select" id="validationCustom03" placeholder="Selecciona un tipo de persona" required>
                            <option v-for="opcion in opcionesTipoPersona" :value="opcion.id">{{ opcion.valor }}</option>
                            </select>   
                            <div class="invalid-feedback">
                              Por favor, seleccione una opción válida.
                            </div>
                          </div>
                        </div>
                        
                          <div class="col-md-2" v-if="TipoPersona == 1 || TipoPersona == 2">
                            <div class="mb-3">
                              <label for="validationCustom02" class="form-label">RFC</label>
                              <input name="rfc" type="text" required placeholder="Ingrese el RFC" v-bind:disabled="CURP !== '' || nombres !== '' || nombreRazonSocial !== '' || primerApellido !== '' || segundoApellido !== '' " class="form-control" v-model="RFC">
                               <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>
                        
                          <div class="col-md-4" v-if="TipoPersona == 1">
                            <div class="mb-3">
                              <label for="validationCustom02"  class="form-label">CURP</label>
                              <input name="curp" placeholder="Ingrese el curp" required type="text" v-bind:disabled="RFC !== '' || nombres !== '' || primerApellido !== '' || segundoApellido !== ''" v-model="CURP" class="form-control">
                              <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>

                          <div class="col-md-4" v-if="TipoPersona == 1">
                            <div class="mb-3">
                              <label for="validationCustom02"  class="form-label">Nombres</label>
                              <input name="nombreRazonSocial" required placeholder="Ingrese el nombre" type="text" v-bind:disabled="RFC !== '' || CURP !== ''" v-model="nombres" class="form-control">                              <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>
  
                          <div class="col-md-8" v-if="TipoPersona == 2">
                            <div class="mb-3">
                              <label for="validationCustom02" class="form-label">Razón Social</label>
                              <input name="nombreRazonSocial" required v-model="nombreRazonSocial" v-bind:disabled="RFC !== ''" type="text" class="form-control" id="validationCustom02" placeholder="Ingrese la Razón Social">
                              <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>

                          <div class="col-md-6" v-if="TipoPersona == 1">
                            <div class="mb-3">
                              <label for="validationCustom02" class="form-label">Primer apellido</label>
                              <input name="primerApellido" type="text" required placeholder="Ingrese el primer apellido" v-bind:disabled="RFC !== '' || CURP !== ''"  v-model="primerApellido" class="form-control">
                              <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>

                          <div class="col-md-6" v-if="TipoPersona == 1">
                            <div class="mb-3">
                              <label for="validationCustom02" class="form-label">Segundo apellido</label>
                              <input name="segundoApellido" type="text" placeholder="Ingrese el segundo apellido" v-bind:disabled="RFC !== '' || CURP !== ''"  v-model="segundoApellido" class="form-control" >
                              <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>
  
                          <div class="d-grid gap-2 d-md-flex justify-content-md-end" v-if="TipoPersona == 1 || TipoPersona == 2">
                            <button class="btn btn-primary" type="button" :disabled="isSearchDisabled" @click="getProducts">Buscar</button> 
                           </div>
                      </div>

                      <div class="table-responsive">
                        <DataTable :data="products" :columns="columns" id="datatable-index-constancias" class=" table-condensed table table-bordered dt-responsive  nowrap w-100"
                          :options="{responsive:true,autoWidth:false, dom:'Bfrtip',language:{
                            search: 'Buscar', zeroRecords:'No hay registros para mostrar',
                            info:'Mostrando del _START_ a _END_ de _TOTAL_ registros',
                            infoFiltered: '(Filtrados de _MAX_ registros.)',
                            paginate:{first: 'Primero',previous:'Anterior',next:'Siguiente', last:'Último'}
                          },}">
                          <thead class="table-light">
                            <tr>
                              <th style="width: 1px;">
                                <div class="form-check font-size-16 align-middle">
                                  <input class="form-check-input" type="checkbox" id="transactionCheck01">
                                  <label class="form-check-label" for="transactionCheck01"></label>
                                </div>
                              </th>
                              <th class="align-middle text-center" style="width: 25%;">RFC</th>
                              <th class="align-middle text-center" style="width: 30%;">CURP</th>
                              <th class="align-middle text-center" style="width: 30%;">Nombre completo</th>
                              <th class="align-middle text-center" style="width: 10;">Acciones</th>
                            </tr>
                          </thead>
                          <tbody style="text-align: center; font-size: 15px;"></tbody>
                        </DataTable>
                      </div>
      





                    </div>

                   


                    <div class="tab-pane fade" id="pills-profile" role="tabpanel" aria-labelledby="pills-profile-tab">
                      <h4 class="card-title mb-4">Datos de busqueda</h4>
                      <div class="row">

                        <div class="col-md-3">
                          <div class="mb-3">
                            <label for="validationCustom04" class="form-label">Tipo de Persona</label>
                            <select name="sancionado[tipoPersonaId]" v-model="TipoPersonaNacional" class="form-select" id="validationCustom03" placeholder="Selecciona un tipo de persona" required>
                            <option v-for="opcion in opcionesTipoPersona" :value="opcion.id">{{ opcion.valor }}</option>
                            </select>   
                            <div class="invalid-feedback">
                              Por favor, seleccione una opción válida.
                            </div>
                          </div>
                        </div>
                        
                          <div class="col-md-3" v-if="TipoPersonaNacional == 1">
                            <div class="mb-3">
                              <label for="validationCustom02"  class="form-label">Nombres</label>
                              <input name="nombreRazonSocial" required placeholder="Ingrese el nombre" type="text" v-model="nombresNacional" class="form-control">                              <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>
  
                          <div class="col-md-9" v-if="TipoPersonaNacional == 2">
                            <div class="mb-3">
                              <label for="validationCustom02" class="form-label">Razón Social</label>
                              <input name="nombreRazonSocial" required v-model="nombreRazonSocialNacional" type="text" class="form-control" id="validationCustom02" placeholder="Ingrese la Razón Social">
                              <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>

                          <div class="col-md-3" v-if="TipoPersonaNacional == 1">
                            <div class="mb-3">
                              <label for="validationCustom02" class="form-label">Primer apellido</label>
                              <input name="primerApellido" type="text" required placeholder="Ingrese el primer apellido"   v-model="primerApellidoNacional" class="form-control">
                              <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>

                          <div class="col-md-3" v-if="TipoPersonaNacional == 1">
                            <div class="mb-3">
                              <label for="validationCustom02" class="form-label">Segundo apellido</label>
                              <input name="segundoApellido" type="text" placeholder="Ingrese el segundo apellido"  v-model="segundoApellidoNacional" class="form-control" >
                              <div class="valid-feedback">
                                ¡Se ve bien!
                              </div>
                            </div>
                          </div>
  
                          <div class="d-grid gap-2 d-md-flex justify-content-md-end" v-if="TipoPersonaNacional == 1 || TipoPersonaNacional == 2">
                            <button class="btn btn-primary" type="button" :disabled="isSearchDisabledNacional" @click="getProductsNacional">Buscar</button> 
                           </div>
                      </div>

                      <div class="table-responsive">
                        <div class="table-responsive">
                          <DataTable :data="productsNacional" :columns="columns" id="datatable-index-constancias-nacional" class=" table-condensed table table-bordered dt-responsive  nowrap w-100"
                            :options="{responsive:true,autoWidth:false, dom:'Bfrtip',language:{
                              search: 'Buscar', zeroRecords:'No hay registros para mostrar',
                              info:'Mostrando del _START_ a _END_ de _TOTAL_ registros',
                              infoFiltered: '(Filtrados de _MAX_ registros.)',
                              paginate:{first: 'Primero',previous:'Anterior',next:'Siguiente', last:'Último'}
                            },}">
                            <thead class="table-light">
                              <tr>
                                <th style="width: 1px;">
                                  <div class="form-check font-size-16 align-middle">
                                    <input class="form-check-input" type="checkbox" id="transactionCheck01">
                                    <label class="form-check-label" for="transactionCheck01"></label>
                                  </div>
                                </th>
                                <th class="align-middle text-center" style="width: 25%;">RFC</th>
                                <th class="align-middle text-center" style="width: 30%;">CURP</th>
                                <th class="align-middle text-center" style="width: 30%;">Nombre completo</th>
                                <th class="align-middle text-center" style="width: 10;">Acciones</th>
                              </tr>
                            </thead>
                            <tbody style="text-align: center; font-size: 15px;"></tbody>
                          </DataTable>
                        </div>
                      </div>
					
                    </div>


                  </div>                
                  
                </div>
              </div>


    
</template>


<style>
	#BuscarCP{
	  width: 80px;
	  height: 34px;
	}

	#nuevoSancion{
	  height: 40px;
	}

  button.detalles {
    /* Quítale los estilos de fondo y borde */
    background: none;
    border: none;
  
    /* Anula cualquier estilo de color de texto */
    color: inherit;
    /* Anula la decoración de subrayado del enlace si se aplica */
    text-decoration: none;
  
    /* Anula el estilo de cursor de puntero si se aplica */
    cursor: auto;
  
    /* Elimina el relleno y el margen si se aplican */
    padding: 0;
    margin: 0;
  
    /* Si deseas quitar el estilo de fuente predeterminado: */
    font-family: inherit;
    font-size: inherit;
    font-weight: inherit;
  }

	.btn-primary-check{
	  background-color: #556ee6;
	  color: white;
	}


	.multiselect-wrapper {
	    height: 10px;
	    padding: .47rem 1.75rem .47rem .75rem;
	    font-size: .8125rem;
	}

	.tipoSancion {
	  height: 70px
	}

	.dashed-line {
	    border-top: 1px solid  #e6e3e3;
	    margin-top: 20px; /* Ajusta la separación si es necesario */
	}

  .multiselect-tag{
    background: #6045ca;
  }

  .dashed-line-row {
    border-top: 1px solid  #e6e3e3;
    margin-top: 20px;
    width:98%;
}

.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dataTables_length {
  display: none;
}


.dataTables_filter{
  display: none;
}

.dt-buttons {
  display: none !important; 
}


#datatable-index-constancias{
  margin-top: 10px;
}

#datatable-index-constancias-nacional{
  margin-top: 10px;
}


@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}


</style>